'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.component = exports.stream = exports.text = exports.element = exports.mount = exports.StreamDom = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _document = require('global/document');

var _document2 = _interopRequireDefault(_document);

var _domEvent = require('@most/dom-event');

var _hold = require('@most/hold');

var _hold2 = _interopRequireDefault(_hold);

var _mostSubject = require('most-subject');

var _eventing = require('./eventing');

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StreamDom = exports.StreamDom = function () {
  function StreamDom() {
    var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var _ref$document = _ref.document;
    var document = _ref$document === undefined ? _document2.default : _ref$document;

    _classCallCheck(this, StreamDom);

    this.document = document;
    var sharedRange = this.sharedRange = document.createRange();

    var DomNodeDescriptor = function () {
      function DomNodeDescriptor(domNode) {
        _classCallCheck(this, DomNodeDescriptor);

        this.domNode = domNode;
      }

      _createClass(DomNodeDescriptor, [{
        key: 'insert',
        value: function insert(domParentNode) {
          var domBeforeNode = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

          domParentNode.insertBefore(this.domNode, domBeforeNode);
        }
      }, {
        key: 'remove',
        value: function remove() {
          var domNode = this.domNode;

          domNode.parentNode.removeChild(domNode);
        }
      }]);

      return DomNodeDescriptor;
    }();

    this.TextNodeDescriptor = function (_DomNodeDescriptor) {
      _inherits(TextNodeDescriptor, _DomNodeDescriptor);

      function TextNodeDescriptor() {
        _classCallCheck(this, TextNodeDescriptor);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TextNodeDescriptor).apply(this, arguments));
      }

      _createClass(TextNodeDescriptor, [{
        key: 'type',
        get: function get() {
          return 'text';
        }
      }]);

      return TextNodeDescriptor;
    }(DomNodeDescriptor);

    this.ElementNodeDescriptor = function (_DomNodeDescriptor2) {
      _inherits(ElementNodeDescriptor, _DomNodeDescriptor2);

      _createClass(ElementNodeDescriptor, [{
        key: 'type',
        get: function get() {
          return 'element';
        }
      }]);

      function ElementNodeDescriptor(_ref2) {
        var domNode = _ref2.domNode;
        var childDescriptors = _ref2.childDescriptors;

        _classCallCheck(this, ElementNodeDescriptor);

        var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(ElementNodeDescriptor).call(this, domNode));

        _this2.childDescriptors = childDescriptors;
        return _this2;
      }

      return ElementNodeDescriptor;
    }(DomNodeDescriptor);

    this.StreamNodeDescriptor = function () {
      _createClass(StreamNodeDescriptor, [{
        key: 'type',
        get: function get() {
          return 'stream';
        }
      }]);

      function StreamNodeDescriptor(_ref3) {
        var domStartNode = _ref3.domStartNode;
        var domEndNode = _ref3.domEndNode;
        var childDescriptors$ = _ref3.childDescriptors$;

        _classCallCheck(this, StreamNodeDescriptor);

        this.domStartNode = domStartNode;
        this.domEndNode = domEndNode;
        this.childDescriptors$ = childDescriptors$;
      }

      _createClass(StreamNodeDescriptor, [{
        key: 'insert',
        value: function insert(domParentNode) {
          var domBeforeNode = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

          domParentNode.insertBefore(this.domStartNode, domBeforeNode);
          domParentNode.insertBefore(this.domEndNode, domBeforeNode);
        }
      }, {
        key: 'remove',
        value: function remove() {
          var domStartNode = this.domStartNode;
          var domEndNode = this.domEndNode;

          sharedRange.setStartBefore(domStartNode);
          sharedRange.setEndAfter(domEndNode);
          sharedRange.deleteContents();
        }
      }]);

      return StreamNodeDescriptor;
    }();
  }

  _createClass(StreamDom, [{
    key: 'mount',
    value: function mount(streamDomNodeInit, domParentNode) {
      var domBeforeNode = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

      var mountedProxy$ = (0, _eventing.createEventStream)();
      var mounted$ = mountedProxy$.thru(_hold2.default);
      var destroyProxy$ = (0, _eventing.createEventStream)();
      var destroy$ = destroyProxy$.multicast();

      var nodeDescriptor = streamDomNodeInit({ mounted$: mounted$, destroy$: destroy$ });
      var domNode = nodeDescriptor.domNode;


      (0, _eventing.attachEventStream)(mountedProxy$, (0, _domEvent.domEvent)('mount', domNode).take(1));
      (0, _eventing.attachEventStream)(destroyProxy$, (0, _domEvent.domEvent)('destroy', domNode).take(1));

      nodeDescriptor.insert(domParentNode, domBeforeNode);

      // TODO: IIRC, it is wrong to emit an event in the same call stack as observe(). Investigate.
      domNode.dispatchEvent(new CustomEvent('mount'));

      destroy$.observe(function () {
        return nodeDescriptor.remove();
      });

      return {
        nodeDescriptor: nodeDescriptor,
        dispose: function dispose() {
          domNode.dispatchEvent(new CustomEvent('destroy'));
        }
      };
    }
  }, {
    key: 'text',
    value: function text(str) {
      var _this3 = this;

      return function () {
        return new _this3.TextNodeDescriptor(_this3.document.createTextNode(str));
      };
    }
  }, {
    key: 'element',
    value: function element(name) {
      var _this4 = this;

      var _ref4 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var _ref4$attributes = _ref4.attributes;
      var attributes = _ref4$attributes === undefined ? {} : _ref4$attributes;
      var _ref4$properties = _ref4.properties;
      var properties = _ref4$properties === undefined ? {} : _ref4$properties;
      var _ref4$eventStreams = _ref4.eventStreams;
      var eventStreams = _ref4$eventStreams === undefined ? {} : _ref4$eventStreams;
      var _ref4$children = _ref4.children;
      var children = _ref4$children === undefined ? [] : _ref4$children;

      var domNode = this.document.createElement(name);

      return function (_ref5) {
        var mounted$ = _ref5.mounted$;
        var destroy$ = _ref5.destroy$;

        var apply = function apply(hash, applicator) {
          var _loop = function _loop(_name) {
            var value = hash[_name];
            if (_is2.default.stream(value)) {
              var value$ = value;
              value$.until(destroy$).observe(function (v) {
                applicator(domNode, _name, v);
              });
            } else {
              applicator(domNode, _name, value);
            }
          };

          for (var _name in hash) {
            _loop(_name);
          }
        };

        var setAttribute = function setAttribute(domNode, name, value) {
          if (_is2.default.boolean(value)) {
            value ? domNode.setAttribute(name, '') : domNode.removeAttribute(name);
          } else {
            domNode.setAttribute(name, value);
          }
        };

        var setProperty = function setProperty(domNode, name, value) {
          return domNode[name] = value;
        };

        apply(attributes, setAttribute);
        apply(properties, setProperty);

        for (var _name2 in eventStreams) {
          var proxy$ = eventStreams[_name2];

          // NOTE: This is probably too magical. Revisit.
          if (_name2 === 'mount' || _name2 === 'destroy') {
            (0, _eventing.attachEventStream)(proxy$, mounted$.map(function () {
              return { target: domNode };
            }));
          } else if (_name2 === 'destroy') {
            (0, _eventing.attachEventStream)(proxy$, destroy$.map(function () {
              return { target: domNode };
            }));
          } else {
            (0, _eventing.attachEventStream)(proxy$, (0, _domEvent.domEvent)(_name2, domNode).until(destroy$));
          }
        }

        var fragment = document.createDocumentFragment();
        var childDescriptors = children.map(function (childInit) {
          var childDescriptor = childInit({ mounted$: mounted$, destroy$: destroy$ });
          childDescriptor.insert(fragment);
          return childDescriptor;
        });
        domNode.appendChild(fragment);

        return new _this4.ElementNodeDescriptor({ domNode: domNode, childDescriptors: childDescriptors, mounted$: mounted$, destroy$: destroy$ });
      };
    }
  }, {
    key: 'stream',
    value: function stream(children$) {
      var _this5 = this;

      return function (_ref6) {
        var mounted$ = _ref6.mounted$;
        var destroy$ = _ref6.destroy$;

        var domStartNode = _this5.document.createComment('');
        var domEndNode = _this5.document.createComment('');

        var mountedGate$ = (0, _mostSubject.subject)();
        var localDestroy$ = (0, _mostSubject.subject)();

        var childMount$ = mountedGate$.chain(function () {
          return mounted$;
        });
        var childDestroy$ = localDestroy$.merge(destroy$);

        // TODO: Rework this to remove need for subjects
        var childDescriptors$ = children$.until(destroy$).loop(function (dispose, children) {
          dispose();

          return {
            seed: function seed() {
              return localDestroy$.next();
            },
            value: children.map(function (childInit) {
              return childInit({
                mounted$: childMount$,
                destroy$: childDestroy$.take(1)
              });
            })
          };
        }, function () {}).tap(function (childDescriptors) {
          var document = _this5.document;
          var sharedRange = _this5.sharedRange;

          sharedRange.setStartAfter(domStartNode);
          sharedRange.setEndBefore(domEndNode);
          sharedRange.deleteContents();

          var fragment = document.createDocumentFragment();
          childDescriptors.forEach(function (childDescriptor) {
            return childDescriptor.insert(fragment);
          });
          sharedRange.insertNode(fragment);

          mountedGate$.next();
        });

        childDescriptors$.drain();

        return new _this5.StreamNodeDescriptor({ domStartNode: domStartNode, domEndNode: domEndNode, childDescriptors$: childDescriptors$ });
      };
    }
  }, {
    key: 'component',
    value: function component(ComponentFactory) {
      var _ref7 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var _ref7$properties = _ref7.properties;
      var properties = _ref7$properties === undefined ? {} : _ref7$properties;
      var _ref7$eventStreams = _ref7.eventStreams;
      var eventStreams = _ref7$eventStreams === undefined ? {} : _ref7$eventStreams;
      var children = _ref7.children;

      var localDestroy$ = (0, _mostSubject.subject)();

      var componentInit = ComponentFactory({ properties: properties, eventStreams: eventStreams, children: children, createEventStream: _eventing.createEventStream });

      return function (_ref8) {
        var mounted$ = _ref8.mounted$;
        var destroy$ = _ref8.destroy$;

        destroy$.take(1).until(localDestroy$).observe(function () {
          return localDestroy$.next();
        });

        localDestroy$.observe(function () {
          return localDestroy$.complete();
        });

        return componentInit({ mounted$: mounted$, destroy$: localDestroy$ });
      };
    }
  }, {
    key: 'expression',
    value: function expression(value) {
      return _is2.default.stream(value) ? stream(value) : text(value);
    }
  }]);

  return StreamDom;
}();

var streamDom = new StreamDom();

exports.default = streamDom;
var mount = exports.mount = streamDom.mount.bind(streamDom),
    element = exports.element = streamDom.element.bind(streamDom),
    text = exports.text = streamDom.text.bind(streamDom),
    stream = exports.stream = streamDom.stream.bind(streamDom),
    component = exports.component = streamDom.component.bind(streamDom);